import React, { Component } from 'react';
import SingleTodo from "./SingleTodo";

class App extends Component {
  constructor() {
    super();
    this.state = {
      currentTodo: "",
      todos: []
    };
  }

  onInputChange = e => {
    this.setState({ currentTodo: e.target.value });
  }

  addTodo = () => {
    let todosCopy = this.state.todos.slice();
    todosCopy.push(this.state.currentTodo);

    this.setState({ currentTodo: "", todos: todosCopy });
  }

  deleteTodo = i => {
    let todosCopy = this.state.todos.slice();

    todosCopy.splice(i, 1);

    this.setState({ todos: todosCopy });
  }

  render() {
    let todosHtml = this.state.todos.map((e, i) => {
      return (
        <SingleTodo i={i} key={i} todo={e} delete={() => this.deleteTodo(i)}/>
      );
    });

    return (
      <div>
        <input
          onChange={this.onInputChange}
          placeholder="What do you have to do"
          value={this.state.currentTodo}/>
        <button onClick={this.addTodo}>Add!</button>
        <br/>
        {this.state.todos.length === 0 ? "No todos yet!" : <ul>{todosHtml}</ul>}
      </div>
    );
  }
}

export default App;
